// file: ll_insert_0.cc
//

// isip include files
//
#include "link_list.h"
#include "link_list_constants.h"

// method: insert_cc
//
// arguments:
//  Link_node* node : (input) a link node to insert in the list
//
// return: a logical_1 to indicate success
//
// this method inserts the specified node at the end of the linked list
//
logical_1 Link_list::insert_cc(Link_node* node_a) {

  // exit ungracefully if the node is null
  //
  if (node_a == (Link_node*)NULL) {
    return ISIP_FALSE;
  }

  // if there is no node present set this at head
  //
  if (head_d == (Link_node*)NULL) {
    head_d = node_a;
  }
  
  // otherwise insert the new node at the end of the list
  //
  else {
    curr_d->insert_cc(node_a);
  }
  
  // set the current position to the end
  //
  curr_d = node_a;

  // exit gracefully
  //
  return ISIP_TRUE;
}
